<?php
/**
 *   
 *
 * @version		0.0.1 RC1
 * @author		HSDN Team
 * @copyright	Copyright (c) 2009 Information Networks Ltd.
 */

class Counter
{
	/*
	 *   
	 * @access	public
	 */
	public $countfile = "./count.dat";

	/*
	 *    
	 * @access	public
	 */
	public $imagedir = "./img";

	/*
	 *   
	 * @access	private
	 */
	private $current_value = 0;

	/*
	 *   
	 * @access	private
	 */
	private $old_value = 0;


	/**
	 *    
	 *
	 * @access	public
	 * @return	void
	 */
	public function set()
	{
		$this->read_file();
		$this->current_value = ($this->old_value + 1);
		$this->write_file();
	}

	/**
	 *    
	 *
	 * @access	private
	 * @return	void
	 */
	private function write_file()
	{
		$fp = fopen($this->countfile, "w");

		if ($fp)
		{
			if (flock($fp, LOCK_EX)) 
			{
				fwrite($fp, $this->current_value);
				flock($fp, LOCK_UN);
			} 

			fclose($fp);
		}
	}

	/**
	 *    
	 *
	 * @access	private
	 * @return	void
	 */
	private function read_file()
	{
		if (!file_exists($this->countfile))
		{
			return;
		}

		$fp = @fopen($this->countfile, "r");
		
		if ($fp)
		{
			$this->old_value = fread($fp, 128);
			fclose($fp);
		}
	}

	/**
	 *  
	 *
	 * @access	public
	 * @param	bool
	 * @return	void
	 */
	public function render($return = FALSE)
	{
		settype($this->current_value, string);

		$ret = '';

		for ($i = 0; $i < strlen($this->current_value); $i++)
		{
			$ret .= '<img src="'.$this->imagedir.'/'.intval($this->current_value{$i}).'.gif" width="68" height="150" />';
		}

		if ($return === TRUE)
		{
			return $ret;
		}

		echo $ret;
	}
}
